SystemOrganization addCategory: #ProxiesTests!

!CompiledMethodProxyHandler classSide methodsFor: '*ProxiesTests' stamp: 'MarianoMartinezPeck 11/28/2010 20:13'!
mareaForTestingUninstallForProxy: aProxy compiledMethod: aMethod
	| oldMethod |
	aProxy mareaIsProxyInstalled ifFalse: [^ nil].
	oldMethod := aMethod.
	self mareaLog: 'The CompiledMethod ', oldMethod mareaPrintString, ' was loaded form file.'.
	oldMethod methodClass  methodDict at: (oldMethod selector) put: oldMethod.
	self mareaLog: 'The Proxy for ', oldMethod mareaPrintString, ' was uninstalled.'.
	self mareaRemoveFile: aProxy mareaFileName.
	aProxy mareaMarkAsUninstalled.
	^ oldMethod.  
! !

TestCase subclass: #AbstractCompiledMethodProxyTest
	instanceVariableNames: 'proxyClass proxyInstance'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ProxiesTests'!

!AbstractCompiledMethodProxyTest methodsFor: 'tests' stamp: 'MarianoMartinezPeck 12/13/2010 20:15'!
crashTestCompiledMethodProxy2
	"A simple CompiledMethodProxy test"
	| aProxy |
	aProxy := self installCompiledMethodProxyOn: PseudoContext  selector: #isPseudoContext.
	[self assert: (PseudoContext methodDict mareaAt: #isPseudoContext) class name equals:  self proxyClassName.
	aProxy zaraza.
	self assert: (PseudoContext methodDict mareaAt: #isPseudoContext) class name equals:  #CompiledMethod.
	] ensure: [ aProxy mareaUninstallIfNeeded].
! !

!AbstractCompiledMethodProxyTest methodsFor: 'helper' stamp: 'MarianoMartinezPeck 11/20/2010 18:21'!
installCompiledMethodProxyOn: aClass selector: aSelector
	^ self proxyClass installOn: aClass selector: aSelector.! !

!AbstractCompiledMethodProxyTest methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 11/30/2010 17:24'!
proxyClass
	^ proxyClass
	

! !

!AbstractCompiledMethodProxyTest methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 11/30/2010 17:25'!
proxyClassInstance
	^ proxyInstance
	

! !

!AbstractCompiledMethodProxyTest methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 11/20/2010 18:11'!
proxyClassName
	^ self proxyClass name! !

!AbstractCompiledMethodProxyTest methodsFor: 'running' stamp: 'MarianoMartinezPeck 12/2/2010 16:54'!
setUp
	CompiledMethodProxyHandler mareaSerializer: FuelMareaSerializer. 
	CompiledMethodProxySmallInteger runningTest: true.
	proxyClass := CompiledMethodProxySmallInteger.
	proxyInstance := CompiledMethodProxySmallInteger new.
	(FileDirectory default fileNamesMatching: '*.swap*') 
		do: [ :aFile | FileDirectory default deleteFileNamed: aFile ].
	SmallInteger mareaResetNumber.! !

!AbstractCompiledMethodProxyTest methodsFor: 'running' stamp: 'MarianoMartinezPeck 11/27/2010 16:48'!
tearDown
	(FileDirectory default fileNamesMatching: '*.swap*') 
		do: [ :aFile | FileDirectory default deleteFileNamed: aFile ].! !

!AbstractCompiledMethodProxyTest methodsFor: 'tests' stamp: 'mariano 11/27/2010 16:10'!
testCompiledMethodMessageSent
	"A simple CompiledMethodProxy test"
	| aProxy |
	
	aProxy := self installCompiledMethodProxyOn: ClassWith1Var selector: #foo.
	[self assert: (ClassWith1Var methodDict mareaAt: #foo) class name equals:  self proxyClassName.
	"Notice that in this case we are not executing the CompiledMethod but instead, sending messages to it.
	In this case, the original method should be back also."
	self assert: (ClassWith1Var methodDict mareaAt: #foo) literals size equals: 3.
	self assert: (ClassWith1Var methodDict mareaAt: #foo) class name equals:  #CompiledMethod.
	] ensure: [ aProxy mareaUninstallIfNeeded].


! !

!AbstractCompiledMethodProxyTest methodsFor: 'tests' stamp: 'mariano 11/27/2010 16:10'!
testCompiledMethodMessageSentByPerform
	"A simple CompiledMethodProxy test"
	| aProxy |
	aProxy := self installCompiledMethodProxyOn: ClassWith1Var selector: #foo.
	[self assert: (ClassWith1Var methodDict mareaAt: #foo) class name equals:  self proxyClassName.
	"Notice that in this case we are not executing the CompiledMethod but instead, sending messages to it.
	In this case, the original method should be back also."
	self assert: ((ClassWith1Var methodDict mareaAt: #foo) perform: #literals) size equals: 3.
	self assert: (ClassWith1Var methodDict mareaAt: #foo) class name equals:  #CompiledMethod.
	] ensure: [ aProxy mareaUninstallIfNeeded].


! !

!AbstractCompiledMethodProxyTest methodsFor: 'tests' stamp: 'mariano 11/27/2010 16:10'!
testCompiledMethodMessageSentByPerformWith
	"A simple CompiledMethodProxy test"
	| aProxy |
	aProxy := self installCompiledMethodProxyOn: ClassWith1Var selector: #foo:.
	[self assert: (ClassWith1Var methodDict mareaAt: #foo:) class name equals:  self proxyClassName.
	"Notice that in this case we are not executing the CompiledMethod but instead, sending messages to it.
	In this case, the original method should be back also."
	self assert: ((ClassWith1Var methodDict mareaAt: #foo:) perform: #literals) size equals: 3.
	self assert: (ClassWith1Var methodDict mareaAt: #foo:) class name equals:  #CompiledMethod.
	] ensure: [ aProxy mareaUninstallIfNeeded].


! !

!AbstractCompiledMethodProxyTest methodsFor: 'tests' stamp: 'mariano 11/27/2010 16:10'!
testCompiledMethodMessageSentByPerformWithNotUnderstood
	"A simple CompiledMethodProxy test"
	| aProxy |
	aProxy := self installCompiledMethodProxyOn: ClassWith1Var selector: #foo.
	[self assert: (ClassWith1Var methodDict mareaAt: #foo) class name equals:  self proxyClassName.
	"Notice that in this case we are not executing the CompiledMethod but instead, sending messages to it.
	In this case, the original method should be back also."
	self should: [(ClassWith1Var methodDict mareaAt: #foo) perform: #nonExistentMethod] raise: Error.
	self assert: (ClassWith1Var methodDict mareaAt: #foo) class name equals:  #CompiledMethod.
	] ensure: [ aProxy mareaUninstallIfNeeded].


! !

!AbstractCompiledMethodProxyTest methodsFor: 'tests' stamp: 'mariano 11/27/2010 16:10'!
testCompiledMethodMessageSentByPerformWithNotUnderstood2
	"A simple CompiledMethodProxy test"
	| aProxy |
	aProxy := self installCompiledMethodProxyOn: ClassWith1Var selector: #foo.
	[self assert: (ClassWith1Var methodDict mareaAt: #foo) class name equals:  self proxyClassName.
	"Notice that in this case we are not executing the CompiledMethod but instead, sending messages to it.
	In this case, the original method should be back also." 
	self should: [(ClassWith1Var methodDict mareaAt: #foo) perform: #fooDNU] raise: Error.
	self assert: (ClassWith1Var methodDict mareaAt: #foo) class name equals:  #CompiledMethod.
	] ensure: [ aProxy mareaUninstallIfNeeded].


! !

!AbstractCompiledMethodProxyTest methodsFor: 'tests' stamp: 'mariano 11/27/2010 16:01'!
testCompiledMethodProxy
	"A simple CompiledMethodProxy test"
	| aProxy |
	aProxy := self installCompiledMethodProxyOn: ClassWith1Var selector: #foo.
	[self assert: (ClassWith1Var methodDict mareaAt: #foo) class name equals:  self proxyClassName.
	self assert: (ClassWith1Var new foo = 'foo').
	self assert: (ClassWith1Var methodDict mareaAt: #foo) class name equals:  #CompiledMethod.
	] ensure: [ aProxy mareaUninstallIfNeeded].
! !

!AbstractCompiledMethodProxyTest methodsFor: 'tests' stamp: 'mariano 11/27/2010 16:10'!
testCompiledMethodProxyAllInstalledProxiesCount
	"A simple CompiledMethodProxy test"
	| aProxy aProxy2 aProxy3 |
	aProxy := self installCompiledMethodProxyOn: ClassWith1Var selector: #foo.
	aProxy2 := self installCompiledMethodProxyOn: ClassWith1Var selector: #foo2.
	aProxy3 := self installCompiledMethodProxyOn: ClassWith1Var selector: #foo3.
	[self assert: self proxyClass mareaAllInstalledProxiesCount equals: 3.
	"This will automatically uninstall the proxy"
	ClassWith1Var new foo.
	self assert: self proxyClass mareaAllInstalledProxiesCount equals: 2.
	aProxy2 mareaUninstallIfNeeded. 
	self assert: self proxyClass mareaAllInstalledProxiesCount equals: 1.
	] ensure: [ 
		aProxy mareaUninstallIfNeeded.
		aProxy2 mareaUninstallIfNeeded.
		aProxy3 mareaUninstallIfNeeded.].
! !

!AbstractCompiledMethodProxyTest methodsFor: 'tests' stamp: 'mariano 11/27/2010 16:10'!
testCompiledMethodProxyAndGC
	"A simple CompiledMethodProxy test"
	| aProxy methodsInstCountFirst  methodsInstCountEnd proxyCount proxyCountEnd|
	MCMethodDefinition shutDown. 
	3 timesRepeat: [Smalltalk garbageCollect].
	methodsInstCountFirst := CompiledMethod instanceCount.
	proxyCount := self proxyClass instanceCount.
	aProxy := self installCompiledMethodProxyOn: ClassWith1Var selector: #foo.
	[self assert: (ClassWith1Var methodDict mareaAt: #foo) class name equals:  self proxyClassName.
	"This line is important because the MCMethodDefinition have references to the CompiledMethod"
	MCMethodDefinition shutDown. 
	3 timesRepeat: [Smalltalk garbageCollect].
	methodsInstCountEnd := CompiledMethod instanceCount.
	proxyCountEnd := self proxyClass instanceCount.
	self assert: (methodsInstCountFirst - 1) equals: methodsInstCountEnd.
	(self proxyClass = SmallInteger) ifFalse: [self assert: (proxyCount + 1) equals: proxyCountEnd].
	self assert: (ClassWith1Var new foo = 'foo').
	self assert: (ClassWith1Var methodDict mareaAt: #foo) class name equals:  #CompiledMethod.
	aProxy := nil.
	MCMethodDefinition shutDown. 
	3 timesRepeat: [Smalltalk garbageCollect].
	methodsInstCountEnd := CompiledMethod instanceCount.
	proxyCountEnd := self proxyClass instanceCount.
	self assert: methodsInstCountFirst equals: methodsInstCountEnd.
	self assert: proxyCount equals: proxyCountEnd.
	] ensure: [
		aProxy isNil ifFalse: [aProxy mareaUninstallIfNeeded].
		MCMethodDefinition shutDown. 
		Smalltalk garbageCollect].
! !

!AbstractCompiledMethodProxyTest methodsFor: 'tests' stamp: 'mariano 11/27/2010 16:10'!
testCompiledMethodProxyAndPerform
	"A simple CompiledMethodProxy test"
	| aProxy |
	aProxy := self installCompiledMethodProxyOn: ClassWith1Var selector: #foo.
	[self assert: ((ClassWith1Var methodDict mareaAt: #foo) class name = self proxyClassName).
	self assert: ((ClassWith1Var new perform: #foo) = 'foo').
	self assert: ((ClassWith1Var methodDict mareaAt: #foo) class name = #CompiledMethod).
	] ensure: [ aProxy mareaUninstallIfNeeded].
! !

!AbstractCompiledMethodProxyTest methodsFor: 'tests' stamp: 'mariano 11/27/2010 16:10'!
testCompiledMethodProxyAndPerformWith
	"A simple CompiledMethodProxy test"
	| aProxy |
	aProxy := self installCompiledMethodProxyOn: ClassWith1Var selector: #foo:.
	[self assert: (ClassWith1Var methodDict mareaAt: #foo:) class name equals:  self proxyClassName.
	self assert: (ClassWith1Var new perform: #foo: with: 2) equals: 'foo'.
	self assert: (ClassWith1Var methodDict mareaAt: #foo) class name equals:  #CompiledMethod.
	] ensure: [ aProxy mareaUninstallIfNeeded].
! !

!AbstractCompiledMethodProxyTest methodsFor: 'tests' stamp: 'mariano 11/27/2010 16:10'!
testCompiledMethodProxyAndPerformWithNotUnderstood2
	"A simple CompiledMethodProxy test"
	| aProxy |
	aProxy := self installCompiledMethodProxyOn: ClassWith1Var selector: #fooDNU.
	[self assert: (ClassWith1Var methodDict mareaAt: #fooDNU) class name equals:  self proxyClassName.
	self should: [ClassWith1Var new perform: #fooDNU ] raise: Error. 
	self assert: (ClassWith1Var methodDict mareaAt: #fooDNU) class name equals:  #CompiledMethod.
	] ensure: [ aProxy mareaUninstallIfNeeded].
! !

!AbstractCompiledMethodProxyTest methodsFor: 'tests' stamp: 'mariano 11/27/2010 16:10'!
testCompiledMethodProxyCaseSensitive
	"A simple CompiledMethodProxy test"
	| aProxy aProxy2 |
	aProxy := self installCompiledMethodProxyOn: ClassWith1Var selector: #foo.
	aProxy2 := self installCompiledMethodProxyOn: ClassWith1Var selector: #fOO.
	
	[self assert: (ClassWith1Var methodDict mareaAt: #foo) class name equals: self proxyClassName.
	self assert: (ClassWith1Var methodDict mareaAt: #fOO) class name equals: self proxyClassName.
	self assert: ClassWith1Var new foo equals: 'foo'.
	self assert: (ClassWith1Var methodDict mareaAt: #foo) class name equals: #CompiledMethod.
	self assert: (ClassWith1Var methodDict mareaAt: #fOO) class name equals: self proxyClassName.
	self assert: (ClassWith1Var new fOO = 'fOO').
	self assert: (ClassWith1Var methodDict mareaAt: #foo) class name equals: #CompiledMethod.
	self assert: (ClassWith1Var methodDict mareaAt: #fOO) class name equals: #CompiledMethod.
	] ensure: [ 
		aProxy mareaUninstallIfNeeded.
		aProxy2 mareaUninstallIfNeeded].
! !

!AbstractCompiledMethodProxyTest methodsFor: 'tests' stamp: 'mariano 11/27/2010 16:10'!
testCompiledMethodProxyCategory
	"A simple CompiledMethodProxy test"
	| aProxy |
	self assert: (ClassWith1Var >> #foo) category = #accessing.
	aProxy := self installCompiledMethodProxyOn: ClassWith1Var selector: #foo.
	[self assert: (ClassWith1Var methodDict mareaAt: #foo) class name equals: self proxyClassName.
	self assert: ClassWith1Var new foo equals: 'foo'.
	self assert: (ClassWith1Var methodDict mareaAt: #foo) class name equals: #CompiledMethod.
	self assert: (ClassWith1Var >> #foo) category equals:  #accessing.
	] ensure: [ aProxy mareaUninstallIfNeeded].
! !

!AbstractCompiledMethodProxyTest methodsFor: 'tests' stamp: 'mariano 11/27/2010 16:10'!
testCompiledMethodProxyCategory2
	"A simple CompiledMethodProxy test"
	| aProxy |
	self assert: (ClassWith1Var >> #fooCategory) category equals: #'test - category'.
	self assert: (ClassWith1Var organization listAtCategoryNamed: #'test - category') size equals: 1.
	aProxy := self installCompiledMethodProxyOn: ClassWith1Var selector: #foo.
	self assert: (ClassWith1Var organization listAtCategoryNamed: #'test - category') size equals: 1.
	[self assert: (ClassWith1Var methodDict mareaAt: #foo) class name equals: self proxyClassName.
	self assert: ClassWith1Var new fooCategory equals: 'fooCategory'.
	self assert: (ClassWith1Var methodDict mareaAt: #fooCategory) class name equals: #CompiledMethod.
	self assert: (ClassWith1Var >> #fooCategory) category equals: #'test - category'.
	self assert: (ClassWith1Var organization listAtCategoryNamed: #'test - category') size equals: 1.
	] ensure: [ aProxy mareaUninstallIfNeeded].
! !

!AbstractCompiledMethodProxyTest methodsFor: 'tests' stamp: 'mariano 11/27/2010 16:10'!
testCompiledMethodProxyClassMethod
	"A simple CompiledMethodProxy test"
	| aProxy  aProxyClass|
	aProxy := self installCompiledMethodProxyOn: ClassWith1Var selector: #foo.
	aProxyClass := self proxyClass.
	aProxyClass runningTest: false.
	[self assert: (ClassWith1Var methodDict mareaAt: #foo) mareaClass equals: aProxyClass.
	self assert: (ClassWith1Var methodDict mareaAt: #foo) class equals: CompiledMethod.
	self assert: ClassWith1Var new foo equals: 'foo'.
	self assert: (ClassWith1Var methodDict mareaAt: #foo) class name equals: #CompiledMethod.
	] ensure: [ aProxy mareaUninstallIfNeeded].
! !

!AbstractCompiledMethodProxyTest methodsFor: 'tests' stamp: 'MarianoMartinezPeck 1/17/2011 15:15'!
testCompiledMethodProxyClassMethodNotTesting
	"A simple CompiledMethodProxy test"
	| aProxy |
	CompiledMethodProxySmallInteger runningTest: false.
	aProxy := self installCompiledMethodProxyOn: ClassWith1Var selector: #foo.
	[self assert: (ClassWith1Var methodDict mareaAt: #foo) class name equals:  #CompiledMethod.
	self assert: (ClassWith1Var new foo = 'foo').
	self assert: (ClassWith1Var methodDict mareaAt: #foo) class name equals:  #CompiledMethod.
	] ensure: [ aProxy mareaUninstallIfNeeded].
! !

!AbstractCompiledMethodProxyTest methodsFor: 'tests' stamp: 'MarianoMartinezPeck 11/24/2010 11:55'!
testCompiledMethodProxyDNUMessage
	self should: [self proxyClassInstance perform: #zaraza] raise: MessageNotUnderstood.
	! !

!AbstractCompiledMethodProxyTest methodsFor: 'tests' stamp: 'mariano 11/27/2010 16:10'!
testCompiledMethodProxyDifficult
	"A simple CompiledMethodProxy test"
	| aProxy |
	
	aProxy := self installCompiledMethodProxyOn: TestRunner selector: #addMethodsUnderTestIn:to:.
	[self assert: (TestRunner methodDict mareaAt: #addMethodsUnderTestIn:to:) class name equals: self proxyClassName.
	TestRunner new addMethodsUnderTestIn: (Array with: (PackageInfo named: 'VMMaker')) to: (OrderedCollection with: CompiledMethod toReturnSelf).
	self assert: (TestRunner methodDict mareaAt: #addMethodsUnderTestIn:to:) class name equals: #CompiledMethod.
	] ensure: [ aProxy mareaUninstallIfNeeded].
! !

!AbstractCompiledMethodProxyTest methodsFor: 'tests' stamp: 'mariano 11/27/2010 16:10'!
testCompiledMethodProxyFlushCache
	"A simple CompiledMethodProxy test"
	| aProxy anObject |
	anObject := ClassWith1Var new. 
	aProxy := self installCompiledMethodProxyOn: ClassWith1Var selector: #fooSomething.
	[self assert: (ClassWith1Var methodDict mareaAt: #fooSomething) class name equals: self proxyClassName.
	self assert: anObject fooSomething equals: 'fooSomething'.
	self assert: anObject fooSomething equals: 'fooSomething'.
	self assert: (ClassWith1Var methodDict mareaAt: #fooSomething) class name equals: #CompiledMethod.
	self assert: anObject fooSomething equals: 'fooSomething'.
	] ensure: [ aProxy mareaUninstallIfNeeded].
! !

!AbstractCompiledMethodProxyTest methodsFor: 'tests' stamp: 'mariano 11/27/2010 16:10'!
testCompiledMethodProxyInstallTwice
	"A simple CompiledMethodProxy test"
	| aProxy aProxy2 |
	aProxy := self installCompiledMethodProxyOn: ClassWith1Var selector: #foo.
	self shouldnt: [aProxy2 := self installCompiledMethodProxyOn: ClassWith1Var selector: #foo] raise: Error.
	[self assert: (ClassWith1Var methodDict mareaAt: #foo) class name equals: self proxyClassName.
	self assert: ClassWith1Var new foo equals: 'foo'.
	self assert: (ClassWith1Var methodDict mareaAt: #foo) class name equals: #CompiledMethod.
	] ensure: [ aProxy mareaUninstallIfNeeded].


! !

!AbstractCompiledMethodProxyTest methodsFor: 'tests' stamp: 'MarianoMartinezPeck 11/28/2010 23:09'!
testCompiledMethodProxySwapDNUMessage
	"A simple CompiledMethodProxy test"
	| aProxy |
	aProxy := self installCompiledMethodProxyOn: ClassWithDNU selector: #doesNotUnderstand:.
	[self assert: (ClassWithDNU methodDict mareaAt: #doesNotUnderstand:) class name equals:  self proxyClassName.
	self assert: (ClassWithDNU new doesNotUnderstand: 'zaraza') equals: 'dnu'.
	self assert: (ClassWithDNU methodDict mareaAt: #doesNotUnderstand:) class name equals:  #CompiledMethod.
	] ensure: [ aProxy mareaUninstallIfNeeded].

	aProxy := self installCompiledMethodProxyOn: ClassWithDNU selector: #doesNotUnderstand:.
	[self assert: (ClassWithDNU methodDict mareaAt: #doesNotUnderstand:) class name equals:  self proxyClassName.
	self assert: (ClassWithDNU new zaraza) equals: 'dnu'.
	self assert: (ClassWithDNU methodDict mareaAt: #doesNotUnderstand:) class name equals:  #CompiledMethod.
	] ensure: [ aProxy mareaUninstallIfNeeded].

	aProxy := self installCompiledMethodProxyOn: ClassWithDNU selector: #doesNotUnderstand:.
	[self assert: (ClassWithDNU methodDict mareaAt: #doesNotUnderstand:) class name equals:  self proxyClassName.
	self should: [(ClassWithDNU methodDict mareaAt: #doesNotUnderstand:) zaraza] raise: MessageNotUnderstood.
	self assert: (ClassWithDNU methodDict mareaAt: #doesNotUnderstand:) class name equals:  #CompiledMethod.
	] ensure: [ aProxy mareaUninstallIfNeeded].

	aProxy := self installCompiledMethodProxyOn: ClassWithDNU selector: #doesNotUnderstand:.
	[self assert: (ClassWithDNU methodDict mareaAt: #doesNotUnderstand:) class name equals:  self proxyClassName.
	self should: [(ClassWithDNU methodDict mareaAt: #doesNotUnderstand:) zaraza] raise: MessageNotUnderstood.
	self assert: (ClassWithDNU methodDict mareaAt: #doesNotUnderstand:) class name equals:  #CompiledMethod.
	] ensure: [ aProxy mareaUninstallIfNeeded].

	aProxy := self installCompiledMethodProxyOn: ClassWithDNU selector: #doesNotUnderstand:.
	[self assert: (ClassWithDNU methodDict mareaAt: #doesNotUnderstand:) class name equals:  self proxyClassName.
	self should: [(ClassWithDNU methodDict mareaAt: #doesNotUnderstand:) doesNotUnderstand: 'aa'] raise: MessageNotUnderstood.
	"The proxy is not uninstalled in this case."
	self assert: (ClassWithDNU methodDict mareaAt: #doesNotUnderstand:) class name equals:  self proxyClassName.
	] ensure: [ aProxy mareaUninstallIfNeeded].! !

!AbstractCompiledMethodProxyTest methodsFor: 'tests' stamp: 'MarianoMartinezPeck 12/1/2010 18:05'!
testCompiledMethodProxySwapOutExternalMethodNeededForSwapIn
	"A simple CompiledMethodProxy test"
	| aProxy aProxy2 internalMethodForTesting |
	"For this test it should be necessary to close all windows that are browsing ClassWith1Var or CompiledMethodProxyHandler"
	aProxy := self installCompiledMethodProxyOn: ClassWith1Var selector: #foo.
	internalMethodForTesting := (CompiledMethodProxyHandler mareaSerializer internalMethodForTesting) copy.
	aProxy2 := self installCompiledMethodProxyOn: internalMethodForTesting methodClass selector: internalMethodForTesting selector.
	[self assert: (ClassWith1Var methodDict mareaAt: #foo) class name equals: self proxyClassName.
	"Now...if I want to swap in  any method.....I will have a loop"
	self should: [ClassWith1Var new foo = 'foo'] raise: CompiledMethodPossibleLoopDetection.
	] ensure: [
		CompiledMethodProxyHandler mareaForTestingUninstallForProxy: aProxy2 compiledMethod: internalMethodForTesting.
		aProxy mareaUninstallIfNeeded.
	].
! !

!AbstractCompiledMethodProxyTest methodsFor: 'tests' stamp: 'mariano 11/27/2010 16:10'!
testCompiledMethodProxySwapOutInternalMethodNeededForSwapIn
	"A simple CompiledMethodProxy test"
	| aProxy aProxy2 bkpMethod |
	"For this test it should be necessary to close all windows that are browsing ClassWith1Var or CompiledMethodProxyHandler"
	aProxy := self installCompiledMethodProxyOn: ClassWith1Var selector: #foo.
	bkpMethod := (CompiledMethodProxyHandler class methodDict at: #mareaLoadCompiledMethodFor:) copy.
	aProxy2 := self installCompiledMethodProxyOn: CompiledMethodProxyHandler class selector: #mareaLoadCompiledMethodFor:.
	[self assert: (ClassWith1Var methodDict mareaAt: #foo) class name equals: self proxyClassName.
	"Now...if I want to swap in  any method.....I will have a loop"
	self should: [ClassWith1Var new foo = 'foo'] raise: CompiledMethodPossibleLoopDetection.
	] ensure: [
		CompiledMethodProxyHandler mareaForTestingUninstallForProxy: aProxy2 compiledMethod: bkpMethod.
		aProxy mareaUninstallIfNeeded.
	].
! !

!AbstractCompiledMethodProxyTest methodsFor: 'tests' stamp: 'mariano 11/27/2010 16:20'!
testCompiledMethodProxyUnInstall
	"A simple CompiledMethodProxy test"
	| aProxy |
	aProxy := self installCompiledMethodProxyOn: ClassWith1Var selector: #foo.
	[self assert: (ClassWith1Var methodDict mareaAt: #foo) class name equals: self proxyClassName.
	self assert: aProxy mareaIsProxyInstalled.
	"This will automatically uninstall the proxy"
	self assert: ClassWith1Var new foo equals: 'foo'.
	self assert: (ClassWith1Var methodDict mareaAt: #foo) class name equals: #CompiledMethod.
	self deny: aProxy mareaIsProxyInstalled.
	] ensure: [ aProxy mareaUninstallIfNeeded].


	aProxy := self installCompiledMethodProxyOn: ClassWith1Var selector: #foo.
	[self assert: (ClassWith1Var methodDict mareaAt: #foo) class name equals: self proxyClassName.
	self assert: aProxy mareaIsProxyInstalled.
	aProxy mareaUninstall.
	self assert: (ClassWith1Var methodDict mareaAt: #foo) class name equals: #CompiledMethod.
	self deny: aProxy mareaIsProxyInstalled.
	] ensure: [ aProxy mareaUninstallIfNeeded].! !

!AbstractCompiledMethodProxyTest methodsFor: 'tests' stamp: 'MarianoMartinezPeck 12/1/2010 18:07'!
testCompiledMethodProxyUnInstallAllInstances
	"A simple CompiledMethodProxy test"
	| aProxy aProxy2 aProxy3 |
	aProxy := self installCompiledMethodProxyOn: ClassWith1Var selector: #foo.
	aProxy2 := self installCompiledMethodProxyOn: ClassWith1Var selector: #foo2.
	aProxy3 := self installCompiledMethodProxyOn: ClassWith1Var selector: #foo3.
	[self assert: aProxy mareaIsProxyInstalled.
	self assert: aProxy2 mareaIsProxyInstalled.
	self assert: aProxy3 mareaIsProxyInstalled.	
	
	"This will automatically uninstall the proxy"
	self assert: ClassWith1Var new foo equals: 'foo'.
	self assert: (ClassWith1Var methodDict mareaAt: #foo) class name equals: #CompiledMethod.
	self deny: aProxy mareaIsProxyInstalled.
	self assert: aProxy2 mareaIsProxyInstalled.
	self assert: aProxy3 mareaIsProxyInstalled.	
	
	self proxyClass mareaUninstallIfNeededAllInstances.
	
	self assert: (ClassWith1Var methodDict mareaAt: #foo2) class name equals: #CompiledMethod.
	self deny: aProxy2 mareaIsProxyInstalled.
	self assert: (ClassWith1Var methodDict mareaAt: #foo3) class name equals: #CompiledMethod.
	self deny: aProxy3 mareaIsProxyInstalled.
	
	] ensure: [ 
		aProxy mareaUninstallIfNeeded.
		aProxy2 mareaUninstallIfNeeded.
		aProxy3 mareaUninstallIfNeeded.].
! !

!AbstractCompiledMethodProxyTest methodsFor: 'tests' stamp: 'mariano 11/27/2010 16:22'!
testCompiledMethodProxyUnInstallMultipleTimes
	| aProxy |
	aProxy := self installCompiledMethodProxyOn: ClassWith1Var selector: #foo.
	[self assert: (ClassWith1Var methodDict mareaAt: #foo) class name equals: self proxyClassName.
	self assert: aProxy mareaIsProxyInstalled.
	aProxy mareaUninstall.
	self should: [aProxy mareaUninstall.] raise: ProxyIsNotInstalled.
	self assert: (ClassWith1Var methodDict mareaAt: #foo) class name equals: #CompiledMethod.
	self deny: aProxy mareaIsProxyInstalled.
	] ensure: [ aProxy mareaUninstallIfNeeded].! !

!AbstractCompiledMethodProxyTest methodsFor: 'tests' stamp: 'MarianoMartinezPeck 12/2/2010 17:00'!
testMethodDictionaryForRecoveringProxiesAssociationsDo
	| aProxy methodSize aProxy2 aProxy3 |
	
	methodSize := (ClassWith1Var >> #foo) size.
	aProxy := self installCompiledMethodProxyOn: ClassWith1Var selector: #foo.
	aProxy2 := self installCompiledMethodProxyOn: ClassWith1Var selector: #foo2.
	aProxy3 := self installCompiledMethodProxyOn: ClassWith1Var selector: #foo3.

	[ClassWith1Var methodDict associationsDo:  [:assoc | self deny: assoc value mareaIsProxy. ].
	
	self deny: aProxy mareaIsProxyInstalled. 
	self deny: aProxy mareaIsProxyInstalled. 
	self deny: aProxy mareaIsProxyInstalled. 
	] ensure: [ 
		aProxy mareaUninstallIfNeeded.
		aProxy2 mareaUninstallIfNeeded.
		aProxy3 mareaUninstallIfNeeded.
	].
! !

!AbstractCompiledMethodProxyTest methodsFor: 'tests' stamp: 'MarianoMartinezPeck 12/2/2010 17:01'!
testMethodDictionaryForRecoveringProxiesAtIfAbsent
	| aProxy methodSize aProxy2 aProxy3 |
	
	methodSize := (ClassWith1Var >> #foo) size.
	aProxy := self installCompiledMethodProxyOn: ClassWith1Var selector: #foo.
	aProxy2 := self installCompiledMethodProxyOn: ClassWith1Var selector: #foo2.
	aProxy3 := self installCompiledMethodProxyOn: ClassWith1Var selector: #foo3.
.
	[self deny: (ClassWith1Var methodDict at: #foo ifAbsent: []) mareaIsProxy.
	
	self deny: aProxy mareaIsProxyInstalled. 
	self assert: aProxy2 mareaIsProxyInstalled. 
	self assert: aProxy3 mareaIsProxyInstalled. 
	] ensure: [ 
		aProxy mareaUninstallIfNeeded.
		aProxy2 mareaUninstallIfNeeded.
		aProxy3 mareaUninstallIfNeeded.
	].
! !

!AbstractCompiledMethodProxyTest methodsFor: 'tests' stamp: 'MarianoMartinezPeck 12/2/2010 17:00'!
testMethodDictionaryForRecoveringProxiesValuesDo
	| aProxy methodSize aProxy2 aProxy3 |
	
	methodSize := (ClassWith1Var >> #foo) size.
	aProxy := self installCompiledMethodProxyOn: ClassWith1Var selector: #foo.
	aProxy2 := self installCompiledMethodProxyOn: ClassWith1Var selector: #foo2.
	aProxy3 := self installCompiledMethodProxyOn: ClassWith1Var selector: #foo3.

	[ClassWith1Var methodDict valuesDo: [:method | self deny: method mareaIsProxy. ].
	
	self deny: aProxy mareaIsProxyInstalled. 
	self deny: aProxy mareaIsProxyInstalled. 
	self deny: aProxy mareaIsProxyInstalled. 
	] ensure: [ 
		aProxy mareaUninstallIfNeeded.
		aProxy2 mareaUninstallIfNeeded.
		aProxy3 mareaUninstallIfNeeded.
	].
! !

!AbstractCompiledMethodProxyTest methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 11/30/2010 18:08'!
testSelector 
	^ testSelector ! !

!AbstractCompiledMethodProxyTest methodsFor: 'tests' stamp: 'MarianoMartinezPeck 12/1/2010 18:04'!
testSerializeCompiledMethod
	| method newMethod serializer |
method := ClassWith1Var >> #foo.
	"method := FormCanvas>> #transformBy:clippingTo:during:smoothing:.
	"
	"
method := (Refactoring class>>#initializeRefactoringOptions ).

method := RefactoryChangeManager class >> #settingsOn:.
"
	serializer := CompiledMethodProxyHandler mareaSerializer. 
	
	"
	serializer := FuelMareaSerializer new.
	"
	
	serializer mareaSerializeAndWriteMethod: method to: 'zaraza'.
	
	newMethod := serializer mareaUnserializeMethodFrom:  'zaraza'.

	self assert: method = newMethod.
	! !

!AbstractCompiledMethodProxyTest methodsFor: 'tests' stamp: 'MarianoMartinezPeck 11/30/2010 17:30'!
xtestCompiledMethodProxyWhenBothUnderstandSameMessage
	| aProxy methodSize |
	methodSize := (ClassWith1Var >> #foo) size.
	aProxy := self installCompiledMethodProxyOn: ClassWith1Var selector: #foo.
	[self assert: (ClassWith1Var methodDict mareaAt: #foo) class name equals:  self proxyClassName.
	self deny: (ClassWith1Var methodDict mareaAt: #foo) size = aProxy size. 
	self assert: (ClassWith1Var methodDict mareaAt: #foo) class name equals:  #CompiledMethod.
	self assert: (ClassWith1Var methodDict mareaAt: #foo) size = methodSize. 
	self assert: (ClassWith1Var methodDict mareaAt: #foo) class name equals:  #CompiledMethod.
	] ensure: [ aProxy mareaUninstallIfNeeded].
! !

AbstractCompiledMethodProxyTest subclass: #CompiledMethodProxyFuelSmallIntegerTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ProxiesTests'!

!CompiledMethodProxyFuelSmallIntegerTest methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 11/30/2010 17:35'!
setUp
	CompiledMethodProxyHandler mareaSerializer: FuelMareaSerializer. 
	SmallInteger runningTest: true.
	SmallInteger mareaResetNumber.
	proxyClass := SmallInteger.
	proxyInstance := 42! !

AbstractCompiledMethodProxyTest subclass: #CompiledMethodProxyFuelTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ProxiesTests'!

!CompiledMethodProxyFuelTest methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 11/30/2010 17:35'!
setUp
	CompiledMethodProxyHandler mareaSerializer: FuelMareaSerializer. 
	CompiledMethodProxy runningTest: true.
	proxyClass := CompiledMethodProxy.
	proxyInstance := CompiledMethodProxy new! !

AbstractCompiledMethodProxyTest subclass: #CompiledMethodProxyReferenceStreamSmallIntegerTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ProxiesTests'!

!CompiledMethodProxyReferenceStreamSmallIntegerTest methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 11/30/2010 17:31'!
setUp
	CompiledMethodProxyHandler mareaSerializer: ReferenceStreamMareaSerializer. 
	SmallInteger runningTest: true.
	SmallInteger mareaResetNumber.
	proxyClass := SmallInteger.
	proxyInstance := 42! !

AbstractCompiledMethodProxyTest subclass: #CompiledMethodProxyReferenceStreamTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ProxiesTests'!

!CompiledMethodProxyReferenceStreamTest methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 11/30/2010 17:33'!
setUp
	CompiledMethodProxyHandler mareaSerializer: ReferenceStreamMareaSerializer. 
	CompiledMethodProxy runningTest: true.
	proxyClass := CompiledMethodProxy.
	proxyInstance := CompiledMethodProxy new! !

AbstractCompiledMethodProxyTest subclass: #CompiledMethodProxySmallIntegerFuelTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ProxiesTests'!

!CompiledMethodProxySmallIntegerFuelTest methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 11/30/2010 17:34'!
setUp
	CompiledMethodProxyHandler mareaSerializer: FuelMareaSerializer. 
	CompiledMethodProxySmallInteger runningTest: true.
	proxyClass := CompiledMethodProxySmallInteger.
	proxyInstance := CompiledMethodProxySmallInteger new


! !

AbstractCompiledMethodProxyTest subclass: #CompiledMethodProxySmallIntegerReferenceStreamTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ProxiesTests'!

!CompiledMethodProxySmallIntegerReferenceStreamTest methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 11/30/2010 17:34'!
setUp
	CompiledMethodProxyHandler mareaSerializer: ReferenceStreamMareaSerializer. 
	CompiledMethodProxySmallInteger runningTest: true.
	proxyClass := CompiledMethodProxySmallInteger.
	proxyInstance := CompiledMethodProxySmallInteger new


! !

TestCase subclass: #ClassProxyFileOutTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ProxiesTests'!

!ClassProxyFileOutTest methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 10/15/2010 19:53'!
testClassSwapRestoreByClass
	"This is a more complex test with several asserts. The important thing in this test is that the original class is restored while sending a message directly to the class"
	| inst proxy |
	inst := ClassWith1Var new.
	self assert: inst foo = 'foo'.
	self assert: inst class = ClassWith1Var.
	proxy := ClassProxyFileOut new.
	"I cannot do a becomeForward:   it has to be a become, since in the proxy I have an instVar pointing to self which will then updated to the class"
	proxy become: ClassWith1Var.
	
	"The following 2 lines freezes the image in case the Proxy extends from ProtoObject instead of Object"
"	self assert: inst class == proxy.
	Transcript show: ClassWith1Var name; cr."
	
	"All the following asserts are based in the assumption that it was a become: and not a becomeForward:"
	
	"ClassWith1Var class was replaced by an instance of ClassProxyInstVar"
	self assert: ClassWith1Var class name = #ClassProxyFileOut.
	self assert: inst class class name =  #ClassProxyFileOut.
	self assert: inst class class class isMeta.
	self assert: proxy class isMeta.
	self assert: proxy name = #ClassWith1Var.
	

	"When seding any message that is not understood to the proxy, the original class is restored"
	ClassWith1Var format.
	
	self assert: ClassWith1Var name = #ClassWith1Var.
	self assert: inst class class isMeta.
	self assert: inst class name =  #ClassWith1Var.
	self assert: proxy class name = #ClassProxyFileOut.

! !

!ClassProxyFileOutTest methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 10/15/2010 19:54'!
testClassSwapRestoreByInstances
	"This is a more complex test with several asserts. The important thing in this test is that the original class is restored while sending a message to an instance of it."
	| inst proxy |
	inst := ClassWith1Var new.
	self assert: inst foo = 'foo'.
	self assert: inst class = ClassWith1Var.
	proxy := ClassProxyFileOut new.
	"I cannot do a becomeForward:   it has to be a become, since in the proxy I have an instVar pointing to self which will then updated to the class"
	proxy become: ClassWith1Var.
	
	"The following 2 lines freezes the image in case the Proxy extends from ProtoObject instead of Object"
"	self assert: inst class == proxy.
	Transcript show: ClassWith1Var name; cr."
	
	"All the following asserts are based in the assumption that it was a become: and not a becomeForward:"
	
	"ClassWith1Var class was replaced by an instance of ClassProxyInstVar"
	self assert: ClassWith1Var class name = #ClassProxyFileOut.
	self assert: inst class class name =  #ClassProxyFileOut.
	self assert: inst class class class isMeta.
	self assert: proxy class isMeta.
	self assert: proxy name = #ClassWith1Var.
	

	"With this #foo the proxy and the class are restored"
	self assert: inst foo = 'foo'.
	
	self assert: ClassWith1Var name = #ClassWith1Var.
	self assert: inst class class isMeta.
	self assert: inst class name =  #ClassWith1Var.
	self assert: proxy class name = #ClassProxyFileOut.

! !

!ClassProxyFileOutTest methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 10/15/2010 19:54'!
testClassSwapSimple
	| inst proxy |
	"This is the simplest test that does the less assert as possible."
	inst := ClassWith1Var new.
	self assert: inst foo = 'foo'.
	proxy := ClassProxyFileOut new.
	proxy become: ClassWith1Var.
	self assert: (inst class == ClassWith1Var).
	self assert: inst foo = 'foo'.
! !

TestCase subclass: #ClassProxyInstVarTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ProxiesTests'!

!ClassProxyInstVarTest methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 1/17/2011 15:18'!
installClassProxyOn: aClass
	^ self proxyClass installOn: aClass
! !

!ClassProxyInstVarTest methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 1/17/2011 15:18'!
proxyClass
	^ ClassProxyInstVar ! !

!ClassProxyInstVarTest methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 1/17/2011 16:43'!
setUp

	(FileDirectory default fileNamesMatching: '*.swap*') 
		do: [ :aFile | FileDirectory default deleteFileNamed: aFile ].
	SmallInteger mareaResetNumber.
	self proxyClass runningTest: true.
	! !

!ClassProxyInstVarTest methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 2/23/2011 16:07'!
testClassSwapRestoreByClass
	"This is a more complex test with several asserts. The important thing in this test is that the original class is restored while sending a message directly to the class"
	
	| inst aProxy className |
	inst := ClassWith1Var new.
	className := ClassWith1Var name.
	aProxy := self installClassProxyOn: ClassWith1Var.
	[self assert: (Smalltalk at: className) ==  ClassWith1Var.
	self assert: (Smalltalk at: className) mareaClass name equals: #ClassProxyInstVar.
	self assert: (Smalltalk at: className) mareaIsProxyInstalled.
	"We are sure that the proxy was installed, now, lets uninstall it sending any message to the class"
	self assert: (Smalltalk at: className) fooClass equals: 'fooClass'.
	
	"Now lets check that the proxy was uninstalled"
	self assert: (Smalltalk at: className) mareaClass name equals: #ClassWith1Var.
	self deny: (Smalltalk at: className) mareaIsProxyInstalled
	
	] ensure: [ aProxy mareaIsProxy ifTrue:  [ aProxy mareaUninstallIfNeeded]].
! !

!ClassProxyInstVarTest methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 1/17/2011 10:43'!
testClassSwapRestoreByInstances
	"This is a more complex test with several asserts. The important thing in this test is that the original class is restored while sending a message to an instance of it."
	| inst proxy |
	
	inst := ClassWith1Var new.
	self assert: inst foo = 'foo'.
	self assert: inst class = ClassWith1Var.
	proxy := ClassProxyInstVar new.
	"I cannot do a becomeForward:   it has to be a become, since in the proxy I have an instVar pointing to self which will then updated to the class"
	self mareaLog: 'grrr'.
	proxy become: ClassWith1Var.
	
	"The following 2 lines freezes the image in case the Proxy extends from ProtoObject instead of Object"
"	self assert: inst class == proxy.
	Transcript show: ClassWith1Var name; cr."
	
	"All the following asserts are based in the assumption that it was a become: and not a becomeForward:"
	
	"ClassWith1Var class was replaced by an instance of ClassProxyInstVar"
	self mareaLog: 'aaa'.
	self assert: ClassWith1Var class name = #ClassProxyInstVar.
	self mareaLog: 'bb'.
	self assert: inst class class name =  #ClassProxyInstVar.
	self mareaLog: 'ac'.
	self assert: inst class class class isMeta.
	self mareaLog: 'd'.
	self assert: proxy class isMeta.
	self mareaLog: 'e'.
	self assert: proxy name = #ClassWith1Var.
	self mareaLog: 'f'.

	"With this #foo the proxy and the class are restored"
	self assert: inst foo = 'foo'.
	
	self assert: ClassWith1Var name = #ClassWith1Var.
	self assert: inst class class isMeta.
	self assert: inst class name =  #ClassWith1Var.
	self assert: proxy class name = #ClassProxyInstVar.

! !

!ClassProxyInstVarTest methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 2/23/2011 15:44'!
testClassSwapSimple

	| inst aProxy |
	inst := ClassWith1Var new.
	aProxy := self installClassProxyOn: ClassWith1Var.
	[ self assert: (inst class == ClassWith1Var).
	self assert: inst foo = 'foo'.
	] ensure: [ aProxy mareaUninstallIfNeeded].
! !

TestCase subclass: #ObjectProxyTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ProxiesTests'!

!ObjectProxyTest methodsFor: 'tests' stamp: 'MarianoMartinezPeck 10/16/2010 21:35'!
XXXXtestOneClassObjectsInner
		
	| b a proxy |
	
	b := ClassWith2Var. 
	a := ClassWith1Var new var1: b.
	
	"We put a proxy and become for B."
	ObjectSwapper new swap: b.
	Transcript show: 'antes';cr.
	self assert: a var1 name = AClassProxy name. 
	Transcript show: 'desp';cr.
	a var1 new class.
	self assert: a var1 new class = ClassWith2Var.
	Transcript show: 'mas desp';cr.
	self assert: a var1 class = ClassWith2Var. 
	Transcript show: 'ree desp';cr.! !

!ObjectProxyTest methodsFor: 'tests' stamp: 'MarianoMartinezPeck 10/21/2010 19:08'!
tearDown
	(FileDirectory default fileNamesMatching: '*.swap') 
		do: [ :aFile | FileDirectory default deleteFileNamed: aFile ].! !

!ObjectProxyTest methodsFor: 'tests' stamp: 'MarianoMartinezPeck 10/21/2010 18:28'!
testAllNomralObjectsAllInner
	"A points to B which is an array that points to C and D. All are normal and inner objects"	
	| c d b a proxy fileName hello today initialInstances finalInstances |
	
	hello := 'Hello'.
	today := Date today.
	
	c := ClassWith1Var new var1: hello.
	d := ClassWith1Var new var1: today.
	b := Array with: c with: d.
	a := ClassWith1Var new var1: b.
	
	3 timesRepeat: [Smalltalk garbageCollect].
	initialInstances := ClassWith1Var instanceCount. 
	d := c := nil.
	
	"We put a proxy and become for B."
	proxy := ObjectProxy new.
	proxy become: b.
	
	3 timesRepeat: [Smalltalk garbageCollect].
	finalInstances := ClassWith1Var instanceCount. 
	"Since nobody else point to B after the become, D an C should be garbage collected"
	self assert: finalInstances = (initialInstances - 2). 
	

	self assert: a var1 = b.
	"With this, using the DNU the proxy will load back the objects"
	self assert: (a var1 first var1 = hello).
	self assert: (a var1 last var1 = today).
	self assert:  ClassWith1Var instanceCount = initialInstances.! !

!ObjectProxyTest methodsFor: 'tests' stamp: 'MarianoMartinezPeck 10/22/2010 17:01'!
testAllNomralObjectsInnerAndShared
	"A points to B which is an array that points to C and D. All are normal and inner objects"	
	| c d b a proxy fileName hello today initialInstances finalInstances |
	
	hello := 'Hello'.
	today := Date today.
	
	c := ClassWith1Var new var1: hello.
	d := ClassWith1Var new var1: today.
	b := Array with: c with: d.
	a := ClassWith1Var new var1: b.
	
	Smalltalk garbageCollect.
	initialInstances := ClassWith1Var instanceCount. 
	d :=  nil.
	"We only nil D. C is still pointing, thus, it is a shared object."
	
	"We put a proxy and become for B."
	proxy := ObjectProxy new.
	proxy become: b.
	
	Smalltalk garbageCollect.
	finalInstances := ClassWith1Var instanceCount. 
	"Since nobody else point to B after the become, D (C will not) should be garbage collected"
	self assert: finalInstances = (initialInstances - 1). 
	

	self assert: a var1 == b.
	"With this, using the DNU the proxy will load back the objects"
	self assert: (a var1 first var1 = hello).
	self assert: (a var1 last var1 = today).
	"We cannot get duplicates of C."
	self assert:  ClassWith1Var instanceCount = initialInstances.
! !

!ObjectProxyTest methodsFor: 'tests' stamp: 'MarianoMartinezPeck 11/17/2010 20:10'!
testObjectProxyClassMessageEquality
	| proxy fileName anObject |
	
	anObject := ClassWith1Var new.
	anObject var1: 'something'.
	proxy := ObjectProxy new.
	
	self assert: anObject class == ClassWith1Var. 
	
	proxy become: anObject.
	
	"We should be always able to get the real class of an object, for out internal usage."
	self assert: anObject mareaClass == ObjectProxy.  
	self assert: (anObject mareaClass name = #ObjectProxy).
	
	self assert: anObject class == ClassWith1Var. 
	self assert: (anObject class name == #ClassWith1Var).
	"This will be useful for code like:
	[anObject class == ClassWith1Var] ifTrue: [ doSomething ]
	If this assert doesnt work, then that code will be broken."
	
	"I don't this a class will overried = but in such case, this should be true anyway:"
	self assert: anObject class = ClassWith1Var. 
	self assert: (anObject class name = #ClassWith1Var).
		
	self assert: (anObject var1 = 'something').
! !

!ObjectProxyTest methodsFor: 'tests' stamp: 'MarianoMartinezPeck 11/17/2010 20:11'!
testObjectProxyClassMessageNextInstance
	| proxy fileName anObject |
	
	anObject := ClassWith1Var new.
	anObject var1: 'something'.
	proxy := ObjectProxy new.
	
	self assert: anObject class == ClassWith1Var. 
	
	proxy become: anObject.
	
	self assert: (ClassWith1Var someInstance class = ClassWith1Var).
	self assert: (anObject nextInstance class = ClassWith1Var).
	
	self assert: anObject class == ClassWith1Var. 
	self assert: (anObject class name = #ClassWith1Var).

	"Now....do we want that #class loads back the original object"
	anObject isByteString.
	
	self assert: (anObject var1 = 'something').
	self assert: anObject class = ClassWith1Var. 
	self assert: (anObject class name = #ClassWith1Var).
	! !

!ObjectProxyTest methodsFor: 'tests' stamp: 'MarianoMartinezPeck 11/17/2010 21:23'!
testObjectProxyClassMethods
	| proxy fileName anObject |
	
	anObject := ClassWith1Var new.
	anObject var1: 'something'.
	proxy := ObjectProxy new.
	
	self assert: anObject class fooClass = 'fooClass'.

	proxy become: anObject.
	
	"Even if the object was swapped, the class has to understand fooClass"
	self assert: anObject class == ClassWith1Var. 
	self assert: anObject class fooClass = 'fooClass'.
	
	self assert: (anObject class name = #ClassWith1Var).

	self assert: (anObject var1 = 'something').
	! !

!ObjectProxyTest methodsFor: 'tests' stamp: 'MarianoMartinezPeck 11/17/2010 21:24'!
testObjectProxyClassMethods2
	| proxy fileName anObject |
	
	anObject := ClassWith1Var new.
	anObject var1: 'something'.
	proxy := ObjectProxy new.
	
	self assert: anObject class fooClass = 'fooClass'.

	proxy become: anObject.
	
	"Even if the object was swapped, the class has to understand fooClass"
	self assert: ClassWith1Var fooClass = 'fooClass'.
	self assert: anObject class == ClassWith1Var. 
	self assert: (anObject class name = #ClassWith1Var).

	self assert: (anObject var1 = 'something').
	! !

!ObjectProxyTest methodsFor: 'tests' stamp: 'MarianoMartinezPeck 10/17/2010 20:43'!
testOneSingleObject
	| proxy fileName anObject |
	
	anObject := 'Hello'.
	
	"We put a proxy and become for B."
	proxy := ObjectProxy new.
	
	proxy become: anObject.
	
	self assert: (anObject class name = #ObjectProxy).
	
	anObject isByteString.
	"With this, using the DNU the proxy will load back the objects"
	self assert: (anObject = 'Hello').
	self assert: (anObject class name = 'Hello' class name).
	! !

!ObjectProxyTest methodsFor: 'tests' stamp: 'MarianoMartinezPeck 10/21/2010 16:12'!
testOneSingleObjectProxyUndetstandsDNU
	"The object that we swap does also understand the message doesNotUnderstand. We have to be sure not to loop and to correctly call both doesNotUnderstand:"
	| proxy fileName anObject |
	
	anObject := ClassWithDNU new.
	
	proxy := ObjectProxy new.
	proxy become: anObject.
	
	self assert: (anObject class name = #ObjectProxy).
	self assert: anObject fooSomething = 'fooSomethingProxy'.
	self assert: (anObject class name = #ObjectProxy).
	
	self assert: (anObject perform: #unExistentMethod) = 'dnu'.
	self assert: (anObject class name =  ClassWithDNU name).
	
	! !

!ObjectProxyTest methodsFor: 'tests' stamp: 'MarianoMartinezPeck 10/17/2010 21:05'!
testOneSingleObjectProxyUndetstandsMessage
	"The proxy does understand the message fooSomething. This can be a problem and this is why proxies should subclass from ProtoObject."
	| proxy fileName anObject |
	
	anObject := 'Hello'.
	
	"We put a proxy and become for B."
	proxy := ObjectProxy new.
	proxy become: anObject.
	
	self assert: (anObject class name = #ObjectProxy).
	self assert: anObject fooSomething = 'fooSomethingProxy'.
	self assert: (anObject class name = #ObjectProxy).
	
	anObject isByteString.
	self assert: (anObject class name =  'Hello' class name).
	
	! !

!ObjectProxyTest methodsFor: 'tests' stamp: 'MarianoMartinezPeck 10/21/2010 18:47'!
testOneSingleObjectProxyUndetstandsMessageOverridden
	"The proxy does understand the message fooSomething, but the original class also understand fooSomething. In this test we can see this is a problem, since the fooSomething of the proxy will be executed instead of the one of the original objects, generating random problems. To avoid this problem, we named all of our proxy methods names, with a special prefix."
	| proxy fileName anObject |
	
	anObject := ClassWith1Var new .
	
	"We put a proxy and become for B."
	proxy := ObjectProxy new.
	proxy become: anObject.
	
	self assert: (anObject class name = #ObjectProxy).
	"this is the problem. We should have 'fooSomething' as an answer, and not 'fooSomethingProxy'. " 
	self assert: anObject fooSomething = 'fooSomethingProxy'.
	self assert: (anObject class name = #ObjectProxy).
	
	anObject foo.
	self assert: (anObject class name =  ClassWith1Var name).
	
	! !

!ObjectProxyTest methodsFor: 'tests' stamp: 'MarianoMartinezPeck 10/21/2010 16:15'!
testOneSingleObjectProxyWithDNU
	"The object that we swap does not understand a the message. This should swap in the object, then thrown DNU error."
	| proxy fileName anObject |
	
	anObject := ClassWith1Var new.
	
	proxy := ObjectProxy new.
	proxy become: anObject.
	
	self assert: (anObject class name = #ObjectProxy).
	self assert: anObject fooSomething = 'fooSomethingProxy'.
	self assert: (anObject class name = #ObjectProxy).
	
	self should: [(anObject perform: #unExistentMethod)] raise: Error.
	self assert: (anObject class name =  ClassWith1Var name).
	
	
! !

!ObjectProxyTest methodsFor: 'tests' stamp: 'MarianoMartinezPeck 10/17/2010 20:32'!
testOneSingleObjectSpecialBytecodes
	| proxy fileName anObject |
	
	anObject := 'Hello'.
	
	"We put a proxy and become for B."
	proxy := ObjectProxy new.
	proxy become: anObject.
	
	self assert: (anObject class name = #ObjectProxy).
	self assert: anObject fooSomething = 'fooSomethingProxy'.
	self assert: (anObject class name = #ObjectProxy).
	
	anObject class.
	self assert: (anObject class name = #ObjectProxy).
	
	anObject isByteString.
	self assert: (anObject class name =  'Hello' class name).
	
	! !

!ObjectProxyTest methodsFor: 'tests' stamp: 'MarianoMartinezPeck 10/19/2010 13:01'!
testOneSingleObjectSpecialSelector
	| proxy fileName anObject |
	
	anObject := 1.5.
	
	"We put a proxy and become for B."
	proxy := ObjectProxy new.
	
	proxy become: anObject.
	
	self assert: (anObject class name = #ObjectProxy).
	
	anObject + 3.2.
	"With this, using the DNU the proxy will load back the objects"
	self assert: (anObject = 1.5).
	self assert: (anObject class name = 1.5 class name).
	! !

!MareaSerializer methodsFor: '*ProxiesTests' stamp: 'MarianoMartinezPeck 11/24/2010 23:29'!
internalMethodForTesting
	^ self shouldBeImplemented ! !

!ReferenceStreamMareaSerializer methodsFor: '*ProxiesTests' stamp: 'MarianoMartinezPeck 11/24/2010 23:29'!
internalMethodForTesting
	^ ReferenceStream methodDict at: #next.! !

!FuelMareaSerializer methodsFor: '*ProxiesTests' stamp: 'MarianoMartinezPeck 11/24/2010 23:38'!
internalMethodForTesting
	^ FLMaterializer methodDict at: #materialize! !

!ObjectProxy methodsFor: '*ProxiesTests' stamp: 'MarianoMartinezPeck 11/17/2010 20:11'!
class
	self mareaLog: 'Will restore object'.
	self become: self mareaLoadBackSerializedObjectsFromFile.
	self mareaLog: 'Object was restored'.
	^ self class! !

!ObjectProxy methodsFor: '*ProxiesTests' stamp: 'MarianoMartinezPeck 10/17/2010 19:13'!
fooSomething
	^ 'fooSomethingProxy'! !

!TestSuite methodsFor: '*ProxiesTests' stamp: 'MarianoMartinezPeck 11/30/2010 18:07'!
tests: aCollectionOfTests
	tests := aCollectionOfTests 
			! !

!ClassProxyHandler classSide methodsFor: '*ProxiesTests' stamp: 'MarianoMartinezPeck 1/17/2011 15:36'!
mareaForTestingUninstallForProxy: aProxy compiledMethod: aMethod
	| oldMethod |
	aProxy mareaIsProxyInstalled ifFalse: [^ nil].
	oldMethod := aMethod.
	self mareaLog: 'The CompiledMethod ', oldMethod mareaPrintString, ' was loaded form file.'.
	oldMethod methodClass  methodDict at: (oldMethod selector) put: oldMethod.
	self mareaLog: 'The Proxy for ', oldMethod mareaPrintString, ' was uninstalled.'.
	self mareaRemoveFile: aProxy mareaFileName.
	aProxy mareaMarkAsUninstalled.
	^ oldMethod.  
! !

!ProtoObject methodsFor: '*ProxiesTests' stamp: 'MarianoMartinezPeck 11/30/2010 15:43'!
size
	^ -1! !
